# renku: v1.dev20180723

variables:
  GIT_STRATEGY: fetch
  GIT_SSL_NO_VERIFY: "true"
  GIT_SUBMODULE_STRATEGY: recursive
  GIT_LFS_SKIP_SMUDGE: 1

stages:
  - build
  - periodic

image_build:
  stage: build
  image: docker:stable
  except:
    refs:
      - schedules
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN http://$CI_REGISTRY
  script:
    - CI_COMMIT_SHA_7=$(echo $CI_COMMIT_SHA | cut -c1-7)
    - docker build --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA_7 .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA_7
  tags:
    - image-build

update_build:
  stage: build
  image: docker:stable
  only:
    refs:
      - schedules
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN http://$CI_REGISTRY
  script:
    - docker build --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA-update .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA-update
  tags:
    - image-build

update:
  stage: periodic
  image:
    name: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA-update
    entrypoint: [""]

  only:
    refs:
      - schedules
  script:
    - git config --global user.name "CR (covid cron)"
    - git config --global user.email "cramakri+covid-cron@ethz.ch"
    - url_host=`git remote get-url origin | sed -e "s/https:\/\/gitlab-ci-token:.*@//g"`
    - cd /tmp/
    - git clone "https://gitlab-ci-token:${CI_TAG_UPLOAD_TOKEN}@${url_host}"
    - cd covid-19-public-data
    - git lfs install --local
    - export BRANCH_NAME="update"_$(date -u +"%Y-%m-%d_%H-%M")
    - PATH=$PATH:~/.local/bin
    - git checkout -b $BRANCH_NAME
    - renku dataset update covid-19_jhu-csse
    - renku dataset add covid-19_jhu-csse --force --source csse_covid_19_data/csse_covid_19_daily_reports https://github.com/CSSEGISandData/COVID-19.git
    - renku dataset update covid-19-tweet-ids
    - renku dataset update openzh-covid-19
    - renku dataset update covid-19-italy
    - renku dataset update covid-19-spain
    - renku dataset update covid-19-us-nyt
    - renku dataset add covid-19-ecdc -d covid-19-ecdc.csv https://opendata.ecdc.europa.eu/covid19/casedistribution/csv --force || true
    - renku dataset add covid-19-chile -s data/*.csv  -s data/covid19_chile.rds https://github.com/itoledor/coronavirus.git --force || true
    - renku dataset add covidtracker https://ocgptweb.azurewebsites.net/CSVDownload -d covidtracker.csv --force || true
    - renku rerun data/covidtracking/states-metadata.json data/covidtracking/states-daily.json
    - renku update --with-siblings
    - git push --set-upstream origin $BRANCH_NAME
